/*
.Howto get port type (RS-232 or RS-422/485) from advantech adv950 driver.
	
    .using devce ioctl code DCMD_CHR_LINESTATUS, it return a int data;
    #define PORTTYPE	0x10
    (data & PORTTYPE) = 0;  <-- RS-232
    (data & PORTTYPE) = 1;  <-- RS-422/485
    data bit[0] 	= RTS
    data bit[1] 	= DTR
    data bit[12]	= CTS
    data bit[13]	= DSR
    data bit[14]	= RI
    data bit[15]	= CD
    
    
example:
*/
#include <stdio.h>
#include <devctl.h>
#include <sys/dcmd_chr.h>
#include <fcntl.h>
#include <string.h>

#define PORTTYPE 0xf
#define MAX_PORT 128


/*
 * serial mode, RS232 RS422 Master  RS485/RS422 Slave
 */
#define SERIAL_MODE_UNKNOWN         	0
#define SERIAL_MODE_RS232           	1
#define SERIAL_MODE_RS422M          	2
#define SERIAL_MODE_RS485ORRS422S   	3


int 
main(void)
{
	int fd, data,i;
	char ttyname[32];
	memset((void*)ttyname,0,32);
	for ( i =1; i<=MAX_PORT; i++ ) 
	{
		sprintf(ttyname,"/dev/ttyAP%d",i);
		 fd = open(ttyname, O_RDWR);
		if(fd == -1)
		{
			return -1;
		}
		if (devctl (fd, DCMD_CHR_LINESTATUS, &data, sizeof(data), NULL))
		{
	   		printf("error\n");
		}
        data = data >> 16;
		if( (data & PORTTYPE) == SERIAL_MODE_RS232 )
			printf("%s was set as RS-232\n",ttyname);
		else if ( (data & PORTTYPE) == SERIAL_MODE_RS422M )
			printf("%s was set as RS-422 master\n",ttyname);
		else if ( (data & PORTTYPE) == SERIAL_MODE_RS485ORRS422S )
		    printf("%s was set as RS-422S/485\n",ttyname);
		else 
		    printf("%s was unknown type\n",ttyname);
		
		close(fd);
	}
	return;
}
	
//. read /etc/system/config/serial-traplist  to get what card's port number is.



